from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, Float, File, String

Rnaplfold_V0_1_0 = CommandToolBuilder(tool="RNAplfold", base_command=["RNAplfold"], inputs=[ToolInput(tag="in_detailed_help", input_type=Boolean(optional=True), prefix="--detailed-help", doc=InputDocumentation(doc="Print help, including all details and hidden\noptions, and exit")), ToolInput(tag="in_full_help", input_type=Boolean(optional=True), prefix="--full-help", doc=InputDocumentation(doc="Print help, including hidden options, and exit")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Be verbose.\n(default=off)")), ToolInput(tag="in_winsize", input_type=Int(optional=True), prefix="--winsize", doc=InputDocumentation(doc="Average the pair probabilities over windows of\ngiven size\n(default=`70')")), ToolInput(tag="in_span", input_type=Int(optional=True), prefix="--span", doc=InputDocumentation(doc="Set the maximum allowed separation of a base\npair to span. I.e. no pairs (i,j) with j-i >\nspan will be allowed. Defaults to winsize if\nparameter is omitted")), ToolInput(tag="in_cut_off", input_type=Float(optional=True), prefix="--cutoff", doc=InputDocumentation(doc="Report only base pairs with an average\nprobability > cutoff in the dot plot\n(default=`0.01')")), ToolInput(tag="in_print_on_the_fly", input_type=Boolean(optional=True), prefix="--print_onthefly", doc=InputDocumentation(doc="Save memory by printing out everything during")), ToolInput(tag="in_u_length", input_type=Int(optional=True), prefix="--ulength", doc=InputDocumentation(doc="Compute the mean probability that regions of\nlength 1 to a given length are unpaired.\nOutput is saved in a _lunp file.\n(default=`31')")), ToolInput(tag="in_opening_energies", input_type=Boolean(optional=True), prefix="--opening_energies", doc=InputDocumentation(doc="Switch output from probabilities to their\nlogarithms, which are NOT exactly the mean\nenergies needed to the respective stretch of\nbases!\nNOTE: This actives -u option.\n(default=off)")), ToolInput(tag="in_noconv", input_type=Boolean(optional=True), prefix="--noconv", doc=InputDocumentation(doc="Do not automatically substitude nucleotide\n'T' with 'U'\n(default=off)")), ToolInput(tag="in_auto_id", input_type=Boolean(optional=True), prefix="--auto-id", doc=InputDocumentation(doc="Automatically generate an ID for each sequence.\n(default=off)")), ToolInput(tag="in_id_prefix", input_type=File(optional=True), prefix="--id-prefix", doc=InputDocumentation(doc="Prefix for automatically generated IDs (as used\nin output file names)\n(default=`sequence')")), ToolInput(tag="in_shape", input_type=File(optional=True), prefix="--shape", doc=InputDocumentation(doc="Use SHAPE reactivity data to guide structure")), ToolInput(tag="in_shape_conversion", input_type=String(optional=True), prefix="--shapeConversion", doc=InputDocumentation(doc="/C/S/L/O  + [optional parameters]\nSelect method to convert SHAPE reactivities to\npairing probabilities.\n(default=`O')")), ToolInput(tag="in_temp", input_type=Int(optional=True), prefix="--temp", doc=InputDocumentation(doc="Rescale energy parameters to a temperature of\ntemp C. Default is 37C.")), ToolInput(tag="in_no_tetra", input_type=Boolean(optional=True), prefix="--noTetra", doc=InputDocumentation(doc="Do not include special tabulated stabilizing\nenergies for tri-, tetra- and hexaloop\nhairpins. Mostly for testing.\n(default=off)")), ToolInput(tag="in_dangles", input_type=Int(optional=True), prefix="--dangles", doc=InputDocumentation(doc="How to treat 'dangling end' energies for\nbases adjacent to helices in free ends and\nmulti-loops\n(default=`2')")), ToolInput(tag="in_no_lp", input_type=Boolean(optional=True), prefix="--noLP", doc=InputDocumentation(doc="Produce structures without lonely pairs\n(helices of length 1).\n(default=off)")), ToolInput(tag="in_no_gu", input_type=Boolean(optional=True), prefix="--noGU", doc=InputDocumentation(doc="Do not allow GU pairs\n(default=off)")), ToolInput(tag="in_no_closing_gu", input_type=Boolean(optional=True), prefix="--noClosingGU", doc=InputDocumentation(doc="Do not allow GU pairs at the end of helices\n(default=off)")), ToolInput(tag="in_param_file", input_type=File(optional=True), prefix="--paramFile", doc=InputDocumentation(doc="Read energy parameters from paramfile, instead\nof using the default parameter set.")), ToolInput(tag="in_binaries", input_type=Boolean(optional=True), prefix="--binaries", doc=InputDocumentation(doc="Output accessibility profiles in binary format\n.  (default=off)")), ToolInput(tag="in_computation_dot", input_type=String(), position=0, doc=InputDocumentation(doc="NOTE: activated per default for sequences")), ToolInput(tag="in_predictions", input_type=String(), position=0, doc=InputDocumentation(doc="--shapeMethod=[D/Z/W] + [optional parameters]")), ToolInput(tag="in_data_dot", input_type=String(), position=0, doc=InputDocumentation(doc="(default=`D')"))], outputs=[ToolOutput(tag="out_id_prefix", output_type=File(optional=True), selector=InputSelector(input_to_select="in_id_prefix", type_hint=File()), doc=OutputDocumentation(doc="Prefix for automatically generated IDs (as used\nin output file names)\n(default=`sequence')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Rnaplfold_V0_1_0().translate("wdl", allow_empty_container=True)

